﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using iqiyiWin.Constant;
using iqiyiWin.Model;
using iqiyiWin.Request;
using iqiyiWin.Response.Film;
using iqiyiWin.Util;
using Newtonsoft.Json;

namespace iqiyiWin.Api
{
    public class City4Film
    {
        public static List<IqiyiFilm> GetWaitShowFileList(IqiyiAccount iqiyiAccount, string cityId)
        {
            var request = new IqiyiH5BaseRequest();

            SortedDictionary<string, string> queryList = JsonConvert.DeserializeObject<SortedDictionary<string, string>>(JsonConvert.SerializeObject(request));
            queryList.Add("cityId", cityId);

            request.Sig = IqiyiSign.Sign(queryList);
            queryList["sig"] = request.Sig;

            var queryText = UrlUtils.BuildQueryStringUrl(queryList);

            var responseStr = HttpUtils.DoGet(new CookieContainer(), Domain.REFERER_DOMAIN, Domain.TICKET_IQIYI + ApiConstant.GET_WAIT_SHOW_FILM + queryText, queryList);

            var response = JsonConvert.DeserializeObject<MovieInfoResponse>(responseStr);

            var filmList = new List<IqiyiFilm>();

            if (response != null && response.Code == "A00000")
            {
                filmList = response.Data.UpcomingSessions.MovieClips;
                //UILogUtils.Info($"爱奇艺票务 【获取城市列表】成功；");
                return filmList;
            }
            else
            {
                //UILogUtils.Error($"爱奇艺票务 【获取城市列表】失败:  {(response == null ? responseStr : response.Msg)}");
                return filmList;
            }
        }
    }
}
