﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using iqiyiWin.Qianzhu.Model.User;
using iqiyiWin.Enums;
using iqiyiWin.Model;
using CinemaWin.Iqiyi.Model.Cinema;

namespace iqiyiWin
{
    public class App
    {
        /// <summary>
        /// Instance
        /// </summary>
        public static readonly App Instance = new App();

        /// <summary>
        /// 爱奇艺热门城市列表
        /// </summary>
        public List<IqiyiH5City> IqiyiHotCitites = new List<IqiyiH5City>();


        /// <summary>
        /// Construct
        /// </summary>
        private App()
        {
        }

        /// <summary>
        /// 环境
        /// </summary>
        public AppEnvironmentEnum Environment { get; set; }

        /// <summary>
        /// 千猪用户账号
        /// </summary>
        public QianzhuUserAccount QianzhuUserAccount { get; set; }

        /// <summary>
        /// 千猪用户
        /// </summary>
        public QianzhuUser QianzhuUser { get; set; }


        public void SetEnvironmentByDescriprtion(string environmentDescriprtion)
        {
            if (string.IsNullOrWhiteSpace(environmentDescriprtion))
            {
                throw new Exception("环境描述不能为空。");
            }

            switch (environmentDescriprtion)
            {
                case "本地":
                    Environment = AppEnvironmentEnum.LOCAL;
                    break;
                case "测试":
                    Environment = AppEnvironmentEnum.TEST;
                    break;
                case "正式":
                    Environment = AppEnvironmentEnum.PROD;
                    break;
                default:
                    throw new Exception("非法环境描述。");
            }
        }

        /// <summary>
        /// 获取千猪域名
        /// </summary>
        /// <returns></returns>
        public string GetQianzhuDomain()
        {
            string domain = "";
            switch (Environment)
            {
                case AppEnvironmentEnum.LOCAL:
                    domain = "http://127.0.0.1:20001";
                    break;
                case AppEnvironmentEnum.TEST:
                    domain = "https://live-test.qianzhu8.com";
                    break;
                case AppEnvironmentEnum.PROD:
                    domain = "https://live.qianzhu8.com";
                    break;
                default:
                    break;
            }
            return domain;
        }
    }
}
