﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace iqiyiWin.Model
{
    public class IqiyiCinema
    {
        /// <summary>
         /// Examples: 15.1, 19.9, 44.9, 22.8, 27.9
         /// </summary>
        [JsonProperty("cinemaPrice")]
        public double CinemaPrice { get; set; }

        /// <summary>
        /// Examples: "15.1", "19.9", "44.9", "22.8", "27.9"
        /// </summary>
        [JsonProperty("cinemaPriceString")]
        public string CinemaPriceString { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("seatStatus")]
        public string SeatStatus { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("cinemaDistanceString")]
        public string CinemaDistanceString { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("movieId")]
        public string MovieId { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("isStored")]
        public bool IsStored { get; set; }

        /// <summary>
        /// Examples: "上海市闵行区永跃路360号万达广场4F-A室", "通河路533弄2号红太阳商业广场3楼（从一楼爱婴室旁手扶梯电梯至三楼）", "上海市闵行区漕宝路3366号上海七宝万科广场5层L501单元", "上海南汇区惠南镇南门大街18号乐购广场5层", "上海市闵行区都市路2700号4F-A，5F-A"
        /// </summary>
        [JsonProperty("cinemaAddress")]
        public string CinemaAddress { get; set; }

        /// <summary>
        /// Examples: 249, 243, 241, 239, 235
        /// </summary>
        [JsonProperty("sessionTotalCount")]
        public string SessionTotalCount { get; set; }

        /// <summary>
        /// Examples: 1401256098, 1401255798, 1401257098, 1401256398, 1401257398
        /// </summary>
        [JsonProperty("areaId")]
        public string AreaId { get; set; }

        /// <summary>
        /// Examples: 382548827, 382413427, 381227327, 180457627, 381934427
        /// </summary>
        [JsonProperty("cinemaId")]
        public string CinemaId { get; set; }

        /// <summary>
        /// Examples: "万达影城（上海浦江万达广场店）", "大光明RGB全激光影城（红太阳店）", "CGV影城（七宝万科广场店）", "大地影院（上海南汇店）", "万达国际影城（颛桥万达广场店）"
        /// </summary>
        [JsonProperty("cinemaName")]
        public string CinemaName { get; set; }

        /// <summary>
        /// Examples: 0.0
        /// </summary>
        [JsonProperty("cinemaDistance")]
        public double CinemaDistance { get; set; }

        /// <summary>
        /// Examples: false, true
        /// </summary>
        [JsonProperty("hasImx")]
        public bool HasImx { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("order")]
        public string Order { get; set; }
    }
}
