﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace iqiyiWin.Model
{
    public class IqiyiFilm
    {
        /// <summary>
        /// Examples: "动作大片《怒火·重案》定档7.30，甄子丹谢霆锋生死搏杀", "贝肯熊2定档 来欢笑一夏", "《俑之城》7月9日全国上映，一起见证千古爱恋！", "皮皮虾总裁", "电影《盛夏未来》“未来已来”预告，张子枫吴磊夏日出逃"
        /// </summary>
        [JsonProperty("title")]
        public string Title { get; set; }

        /// <summary>
        /// Examples: "https://moviepic02.iqiyipic.com/movie/2021/01/27/4b1a796ae29553c5ea40169e78c32076f7a43ba7.jpg@s_2,w_600,h_340,q_100", "https://moviepic03.iqiyipic.com/movie/2021/05/31/3b606c3ea5b656917b51ae9f1ba8f1a6e73d0118.jpg@s_2,w_600,h_340,q_100", "https://moviepic03.iqiyipic.com/movie/2021/06/29/36f0090aeffb8becbb93d53d5a74b730402544dd.jpg@s_2,w_600,h_340,q_100", "https://moviepic05.iqiyipic.com/movie/2021/05/12/d57f63629f2b28d673d0c72b56834d0a1731859e.jpg@s_2,w_600,h_340,q_100", "https://moviepic03.iqiyipic.com/movie/2021/06/10/6d60c62199c047d6666d0a6041e6b5f9282afa5f.jpg@s_2,w_600,h_340,q_100"
        /// </summary>
        [JsonProperty("picUrl")]
        public string PicUrl { get; set; }

        /// <summary>
        /// Examples: 5676626892530200, 2841772787017000, 6453925599269500, 6258999298184200, 3082422541340600
        /// </summary>
        [JsonProperty("tvId")]
        public string TvId { get; set; }

        /// <summary>
        /// Examples: 5676626892530200, 2841772787017000, 6453925599269500, 6258999298184200, 3082422541340600
        /// </summary>
        [JsonProperty("aid")]
        public string Aid { get; set; }

        /// <summary>
        /// Examples: null
        /// </summary>
        [JsonProperty("vid")]
        public string Vid { get; set; }

        /// <summary>
        /// Examples: "01:41", "01:18", "01:37", "01:08", "01:53"
        /// </summary>
        [JsonProperty("duration")]
        public string Duration { get; set; }

        /// <summary>
        /// Examples: "0"
        /// </summary>
        [JsonProperty("ctype")]
        public string Ctype { get; set; }

        /// <summary>
        /// Examples: "0"
        /// </summary>
        [JsonProperty("_pc")]
        public string Pc { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("playCount")]
        public int PlayCount { get; set; }

        /// <summary>
        /// Examples: 2, 5, 4, 1, 3
        /// </summary>
        [JsonProperty("order")]
        public int Order { get; set; }

        /// <summary>
        /// Examples: "2021-01-27", "2021-05-31", "2021-06-29", "2021-05-12", "2021-06-10"
        /// </summary>
        [JsonProperty("createAt")]
        public string CreateAt { get; set; }

        /// <summary>
        /// Examples: 1728564199, 1704275499, 1669123999, 1635634299, 1749172499
        /// </summary>
        [JsonProperty("movieId")]
        public string MovieId { get; set; }

        /// <summary>
        /// Examples: {"movieName":"怒火·重案"}, {"movieName":"贝肯熊2：金牌特工"}, {"movieName":"俑之城"}, {"movieName":"皮皮虾总裁"}, {"movieName":"盛夏未来"}
        /// </summary>
        [JsonProperty("relatedMovieMap")]
        public RelatedMovieMap RelatedMovieMap { get; set; }

        /// <summary>
        /// Examples: null
        /// </summary>
        [JsonProperty("shareUrl")]
        public string ShareUrl { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("unique")]
        public bool Unique { get; set; }
    }
    public class RelatedMovieMap
    {
        /// <summary>
        /// Examples: "怒火·重案", "贝肯熊2：金牌特工", "俑之城", "皮皮虾总裁", "盛夏未来"
        /// </summary>
        [JsonProperty("movieName")]
        public string MovieName { get; set; }
    }
}
