﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace CinemaWin.Iqiyi.Model.Cinema
{
    public class IqiyiH5Cinema
    {
        /// <summary>
        /// Examples: 27.0, 40.0, 38.0, 28.0, 30.9
        /// </summary>
        [JsonProperty("cinemaPrice")]
        public double CinemaPrice { get; set; }

        /// <summary>
        /// Examples: "27", "40", "38", "28", "30.9"
        /// </summary>
        [JsonProperty("cinemaPriceString")]
        public string CinemaPriceString { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("seatStatus")]
        public int SeatStatus { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("cinemaDistanceString")]
        public string CinemaDistanceString { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("movieId")]
        public int MovieId { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("isStored")]
        public bool IsStored { get; set; }

        /// <summary>
        /// Examples: "下沙文渊路499号四季广场5幢2层", "杭州市萧山区市心中路123号旺角城新天地商业步行街8号楼4-5层", "杭州市西湖区学院路77号", "杭州市西湖区文一路298号物美大买场6楼(近万塘路)", "杭州市拱墅区上塘路458号水晶城购物中心7楼"
        /// </summary>
        [JsonProperty("cinemaAddress")]
        public string CinemaAddress { get; set; }

        /// <summary>
        /// Examples: [], [{"name":"杜比全景声","field":"dolby","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"},{"name":"IMAX","field":"imax","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"},{"name":"巨幕","field":"jumu","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"}], [], [{"name":"杜比全景声","field":"dolby","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"}], [{"name":"4K","field":"k4","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"},{"name":"REALD","field":"reald","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"},{"name":"IMAX","field":"imax","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"}]
        /// </summary>
        [JsonProperty("tags")]
        public List<CinemaTag> Tags { get; set; }

        /// <summary>
        /// Examples: 371, 277, 272, 256, 243
        /// </summary>
        [JsonProperty("sessionTotalCount")]
        public int SessionTotalCount { get; set; }

        /// <summary>
        /// Examples: 1401250898, 1401250698, 1401251098, 1401251898, 1401250998
        /// </summary>
        [JsonProperty("areaId")]
        public string AreaId { get; set; }

        /// <summary>
        /// Examples: 381779027, 180742627, 382245627, 180598727, 380930927
        /// </summary>
        [JsonProperty("cinemaId")]
        public string CinemaId { get; set; }

        /// <summary>
        /// Examples: "四季国际影城", "萧山德纳IMAX影城", "晟嘉国际影城", "浙江翠苑电影大世界", "杭州万达影城水晶城店"
        /// </summary>
        [JsonProperty("cinemaName")]
        public string CinemaName { get; set; }

        /// <summary>
        /// Examples: 0.0
        /// </summary>
        [JsonProperty("cinemaDistance")]
        public double CinemaDistance { get; set; }

        /// <summary>
        /// Examples: false, true
        /// </summary>
        [JsonProperty("hasImx")]
        public bool HasImx { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("order")]
        public int Order { get; set; }

        /// <summary>
        /// 拓展字段
        /// 城市id
        /// </summary>
        public string CityId { get; set; }

        /// <summary>
        /// 拓展字段
        /// 城市名称
        /// </summary>
        public string CityName { get; set; }
    }
    public class CinemaTag
    {

        /// <summary>
        /// Examples: "杜比全景声", "IMAX", "巨幕", "4K", "REALD"
        /// </summary>
        [JsonProperty("name")]
        public string Name { get; set; }

        /// <summary>
        /// Examples: "dolby", "imax", "jumu", "k4", "reald"
        /// </summary>
        [JsonProperty("field")]
        public string Field { get; set; }

        /// <summary>
        /// Examples: "common"
        /// </summary>
        [JsonProperty("type")]
        public string Type { get; set; }

        /// <summary>
        /// Examples: "#EF7D52"
        /// </summary>
        [JsonProperty("wireframe")]
        public string Wireframe { get; set; }

        /// <summary>
        /// Examples: "#FFFFFF"
        /// </summary>
        [JsonProperty("background")]
        public string Background { get; set; }

        /// <summary>
        /// Examples: "#EF7D52"
        /// </summary>
        [JsonProperty("colorFont")]
        public string ColorFont { get; set; }
    }
}
