﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace iqiyiWin.Model
{
    public class IqiyiH5Dim
    {
        /// <summary>
        /// Examples: "Mozilla/5.0 (iPhone; CPU iPhone OS 13_2_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0.3 Mobile/15E148 Safari/604.1"
        /// </summary>
        [JsonProperty("jn")]
        public string Jn { get; set; } = "Mozilla/5.0 (iPhone; CPU iPhone OS 13_2_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0.3 Mobile/15E148 Safari/604.1";

        /// <summary>
        /// Examples: "zh-CN"
        /// </summary>
        [JsonProperty("cm")]
        public string Cm { get; set; } = "zh-CN";

        /// <summary>
        /// Examples: 24
        /// </summary>
        [JsonProperty("gu")]
        public int Gu { get; set; } = 24;

        /// <summary>
        /// Examples: 3
        /// </summary>
        [JsonProperty("uf")]
        public int Uf { get; set; } = 3;

        /// <summary>
        /// Examples: [812,375]
        /// </summary>
        [JsonProperty("jr")]
        public List<int> Jr { get; set; } = new List<int>() { 812, 375};

        /// <summary>
        /// Examples: [812,375]
        /// </summary>
        [JsonProperty("di")]
        public List<int> Di { get; set; } = new List<int>() { 812, 375 };

        /// <summary>
        /// Examples: -480
        /// </summary>
        [JsonProperty("zp")]
        public int Zp { get; set; } = -480;

        /// <summary>
        /// Examples: 1
        /// </summary>
        [JsonProperty("uh")]
        public int Uh { get; set; } = 1;

        /// <summary>
        /// Examples: 1
        /// </summary>
        [JsonProperty("sh")]
        public int Sh { get; set; } = 1;

        /// <summary>
        /// Examples: 1
        /// </summary>
        [JsonProperty("he")]
        public int He { get; set; } = 1;

        /// <summary>
        /// Examples: 1
        /// </summary>
        [JsonProperty("zo")]
        public int Zo { get; set; } = 1;

        /// <summary>
        /// Examples: "unknown"
        /// </summary>
        [JsonProperty("rv")]
        public string Rv { get; set; } = "unknown";

        /// <summary>
        /// Examples: "Win32"
        /// </summary>
        [JsonProperty("nx")]
        public string Nx { get; set; } = "Win32";

        /// <summary>
        /// Examples: "unknown"
        /// </summary>
        [JsonProperty("iw")]
        public string Iw { get; set; } = "unknown";

        /// <summary>
        /// Examples: []
        /// </summary>
        [JsonProperty("qm")]
        public List<string> Qm { get; set; } = new List<string> { };

        /// <summary>
        /// Examples: "e421d52e63e9bc74e6db153f901ff028"
        /// </summary>
        [JsonProperty("wr")]
        public string Wr { get; set; }

        /// <summary>
        /// Examples: "37d2ac50723da033efc14274b809c431"
        /// </summary>
        [JsonProperty("wg")]
        public string Wg { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("fk")]
        public bool Fk { get; set; } = false;

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("rg")]
        public bool Rg { get; set; } = false;

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("xy")]
        public bool Xy { get; set; } = false;

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("jm")]
        public bool Jm { get; set; } = true;

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("ba")]
        public bool Ba { get; set; } = true;

        /// <summary>
        /// Examples: [1,true,true]
        /// </summary>
        [JsonProperty("tm")]
        public List<object> Tm { get; set; } = new List<object> { 1, true, true};

        /// <summary>
        /// Examples: 6
        /// </summary>
        [JsonProperty("cc")]
        public int Cc { get; set; } = 6;

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("vt")]
        public bool Vt { get; set; } = true;

        /// <summary>
        /// Examples: "ANGLE (Intel, Intel(R) UHD Graphics 630 Direct3D11 vs_5_0 ps_5_0, D3D11-27.20.100.8935)"
        /// </summary>
        [JsonProperty("rr")]
        public string Rr { get; set; } = "ANGLE (Intel, Intel(R) UHD Graphics 630 Direct3D11 vs_5_0 ps_5_0, D3D11-27.20.100.8935)";

        /// <summary>
        /// Examples: "Google Inc. (Intel)"
        /// </summary>
        [JsonProperty("vd")]
        public string Vd { get; set; } = "Google Inc. (Intel)";

        /// <summary>
        /// Examples: "WebGL 1.0 (OpenGL ES 2.0 Chromium)"
        /// </summary>
        [JsonProperty("wv")]
        public string Wv { get; set; } = "WebGL 1.0 (OpenGL ES 2.0 Chromium)";

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("hl")]
        public bool Hl { get; set; } = false;

        /// <summary>
        /// Examples: "7,8"
        /// </summary>
        [JsonProperty("ht")]
        public string Ht { get; set; } = "7,8";

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("au")]
        public bool Au { get; set; } = true;

        /// <summary>
        /// Examples: "b434a361-37f2-e3e7-199e-a26d9c89b4d7"
        /// </summary>
        [JsonProperty("mi")]
        public string Mi { get; set; }

        /// <summary>
        /// Examples: "H5"
        /// </summary>
        [JsonProperty("cl")]
        public string Cl { get; set; } = "H5";

        /// <summary>
        /// Examples: "1.0"
        /// </summary>
        [JsonProperty("sv")]
        public string Sv { get; set; } = "1.0";

        /// <summary>
        /// Examples: "974da1cccc0cac50ba813dab918e10bc"
        /// </summary>
        [JsonProperty("jg")]
        public string Jg { get; set; }

        /// <summary>
        /// Examples: "5095aad833017a5735e6b889f86185d5"
        /// </summary>
        [JsonProperty("fh")]
        public string Fh { get; set; }

        /// <summary>
        /// Examples: [false,null,null,null]
        /// </summary>
        [JsonProperty("ifm")]
        public List<object> Ifm { get; set; } =  new List<object> { false, null, null, null };

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("ex")]
        public string Ex { get; set; } = "";

        /// <summary>
        /// Examples: "off"
        /// </summary>
        [JsonProperty("dv")]
        public string Dv { get; set; } = "off";

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("pv")]
        public bool Pv { get; set; } = true;

        /// <summary>
        /// Examples: 1013
        /// </summary>
        [JsonProperty("qa")]
        public int Qa { get; set; } = 1013;
    }
}