﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace CinemaWin.Iqiyi.Model.Cinema
{
    public class IqiyiH5Movie
    {
        /// <summary>
        /// Examples:
        /// </summary>
        [JsonProperty("sessions")]
        public List<Session> Sessions { get; set; }

        /// <summary>
        /// Examples: "9.2", "8.5", "6.5", "8.4", "8.2"
        /// </summary>
        [JsonProperty("scoreString")]
        public string ScoreString { get; set; }

        /// <summary>
        /// Examples: 1745301399, 1665453699, 1749226399, 1743617799, 1647588499
        /// </summary>
        [JsonProperty("movieId")]
        public string MovieId { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("isVip")]
        public bool IsVip { get; set; }

        /// <summary>
        /// Examples: {"score":9.2,"type":3}, {"score":8.5,"type":3}, {"type":1,"wantToSee":111}, {"score":8.4,"type":3}, {"score":8.2,"type":3}
        /// </summary>
        [JsonProperty("scoreBlock")]
        public ScoreBlock ScoreBlock { get; set; }

        /// <summary>
        /// Examples: "https://pic0.iqiyipic.com/image/20210205/06/5a/v_154362925_m_601_m3_440_608.jpg", "https://pic6.iqiyipic.com/image/20201012/ee/15/v_115684213_m_601_m18_440_608.jpg", "", "https://pic1.iqiyipic.com/image/20210222/0a/be/v_154005610_m_601_m3_440_608.jpg", "https://pic3.iqiyipic.com/image/20210120/a9/dd/v_122200379_m_601_m16_440_608.jpg"
        /// </summary>
        [JsonProperty("picUrl")]
        public string PicUrl { get; set; }

        /// <summary>
        /// Examples: 1400251193
        /// </summary>
        [JsonProperty("currentCityId")]
        public int CurrentCityId { get; set; }

        /// <summary>
        /// Examples: 9.2, 8.5, 6.5, 8.4, 8.2
        /// </summary>
        [JsonProperty("score")]
        public double Score { get; set; }

        /// <summary>
        /// Examples: false, true
        /// </summary>
        [JsonProperty("isPresell")]
        public bool IsPresell { get; set; }

        /// <summary>
        /// Examples: 94, 72, 62, 42, 33
        /// </summary>
        [JsonProperty("sessionCount")]
        public int SessionCount { get; set; }

        /// <summary>
        /// Examples: "你好，李焕英", "唐人街探案3", "寻龙传说", "人潮汹涌", "刺杀小说家"
        /// </summary>
        [JsonProperty("movieName")]
        public string MovieName { get; set; }

        /// <summary>
        /// Examples: true, false
        /// </summary>
        [JsonProperty("selected")]
        public bool Selected { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("order")]
        public int Order { get; set; }

        /// <summary>
        /// Examples: "111"
        /// </summary>
        [JsonProperty("wantToSee")]
        public string WantToSee { get; set; }

        /// <summary>
        /// Examples: 111
        /// </summary>
        [JsonProperty("wantToSeeNum")]
        public int? WantToSeeNum { get; set; }
    }
    public class ScoreBlock
    {

        /// <summary>
        /// Examples: 9.2, 8.5, 8.4, 8.2, 7.4
        /// </summary>
        [JsonProperty("score")]
        public double Score { get; set; }

        /// <summary>
        /// Examples: 3, 1
        /// </summary>
        [JsonProperty("type")]
        public int Type { get; set; }

        /// <summary>
        /// Examples: 111
        /// </summary>
        [JsonProperty("wantToSee")]
        public int? WantToSee { get; set; }
    }
    public class Session
    {

        /// <summary>
        /// Examples: {"originPriceMsg":"30.0元","priceMsg":"限时特惠￥6.9抢","displayName":"购买礼包，立得30元优惠券","displayNameHighlight":"购买礼包，立得#30#元优惠券","name":"礼包","hasShow":true}, {"originPriceMsg":"30.0元","priceMsg":"限时特惠￥6.9抢","displayName":"购买礼包，立得30元优惠券","displayNameHighlight":"购买礼包，立得#30#元优惠券","name":"礼包","hasShow":true}, {"originPriceMsg":"30.0元","priceMsg":"限时特惠￥6.9抢","displayName":"购买礼包，立得30元优惠券","displayNameHighlight":"购买礼包，立得#30#元优惠券","name":"礼包","hasShow":true}, {"originPriceMsg":"30.0元","priceMsg":"限时特惠￥6.9抢","displayName":"购买礼包，立得30元优惠券","displayNameHighlight":"购买礼包，立得#30#元优惠券","name":"礼包","hasShow":true}, {"originPriceMsg":"30.0元","priceMsg":"限时特惠￥6.9抢","displayName":"购买礼包，立得30元优惠券","displayNameHighlight":"购买礼包，立得#30#元优惠券","name":"礼包","hasShow":true}
        /// </summary>
        [JsonProperty("giftPackageInfo")]
        public GiftPackageInfo GiftPackageInfo { get; set; }

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("hasGiftPkg")]
        public bool HasGiftPkg { get; set; }

        /// <summary>
        /// Examples: {"priceId":0,"displayName":"","displaySubName":"","desc":"","pictureUrl":"","priceChangeNum":0,"priceChangeNumMax":0,"priceChangeSingle":"","startDate":"","endDate":"","createDate":"","valid":false,"movieIds":""}, {"priceId":0,"displayName":"","displaySubName":"","desc":"","pictureUrl":"","priceChangeNum":0,"priceChangeNumMax":0,"priceChangeSingle":"","startDate":"","endDate":"","createDate":"","valid":false,"movieIds":""}, {"priceId":0,"displayName":"","displaySubName":"","desc":"","pictureUrl":"","priceChangeNum":0,"priceChangeNumMax":0,"priceChangeSingle":"","startDate":"","endDate":"","createDate":"","valid":false,"movieIds":""}, {"priceId":0,"displayName":"","displaySubName":"","desc":"","pictureUrl":"","priceChangeNum":0,"priceChangeNumMax":0,"priceChangeSingle":"","startDate":"","endDate":"","createDate":"","valid":false,"movieIds":""}, {"priceId":0,"displayName":"","displaySubName":"","desc":"","pictureUrl":"","priceChangeNum":0,"priceChangeNumMax":0,"priceChangeSingle":"","startDate":"","endDate":"","createDate":"","valid":false,"movieIds":""}
        /// </summary>
        [JsonProperty("promotionInfo")]
        public PromotionInfo PromotionInfo { get; set; }

        /// <summary>
        /// Examples: "温馨提示：电影开场前0分钟停止在线选座"
        /// </summary>
        [JsonProperty("tips")]
        public string Tips { get; set; }

        /// <summary>
        /// Examples: "20210304", "20210305", "20210306", "20210307", "20210308"
        /// </summary>
        [JsonProperty("rawDate")]
        public string RawDate { get; set; }

        /// <summary>
        /// Examples: true, false
        /// </summary>
        [JsonProperty("isLowest")]
        public bool IsLowest { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("promotionDisplay")]
        public bool PromotionDisplay { get; set; }

        /// <summary>
        /// Examples: true, false
        /// </summary>
        [JsonProperty("isShownOff")]
        public bool IsShownOff { get; set; }

        /// <summary>
        /// Examples: "3-4", "3-5", "3-6", "3-7", "3-8"
        /// </summary>
        [JsonProperty("curDate")]
        public string CurDate { get; set; }

        /// <summary>
        /// Examples: "https://act.iqiyi.com/act/pages/libao_goumai/app.html?channel=piaoh5_pqy"
        /// </summary>
        [JsonProperty("giftPackageH5Url")]
        public string GiftPackageH5Url { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("outDateTime")]
        public int OutDateTime { get; set; }

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("isReleased")]
        public bool IsReleased { get; set; }

        /// <summary>
        /// Examples: 
        /// </summary>
        [JsonProperty("value")]
        public List<IqiyiH5Session> Value { get; set; }

        /// <summary>
        /// Examples: "今天03-04", "明天03-05", "后天03-06", "周日03-07", "周一03-08"
        /// </summary>
        [JsonProperty("key")]
        public string Key { get; set; }
    }

    public class GiftPackageInfo
    {

        /// <summary>
        /// Examples: "30.0元"
        /// </summary>
        [JsonProperty("originPriceMsg")]
        public string OriginPriceMsg { get; set; }

        /// <summary>
        /// Examples: "限时特惠￥6.9抢"
        /// </summary>
        [JsonProperty("priceMsg")]
        public string PriceMsg { get; set; }

        /// <summary>
        /// Examples: "购买礼包，立得30元优惠券"
        /// </summary>
        [JsonProperty("displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Examples: "购买礼包，立得#30#元优惠券"
        /// </summary>
        [JsonProperty("displayNameHighlight")]
        public string DisplayNameHighlight { get; set; }

        /// <summary>
        /// Examples: "礼包"
        /// </summary>
        [JsonProperty("name")]
        public string Name { get; set; }

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("hasShow")]
        public bool HasShow { get; set; }
    }
    public class PromotionInfo
    {

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("priceId")]
        public int PriceId { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("displaySubName")]
        public string DisplaySubName { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("desc")]
        public string Desc { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("pictureUrl")]
        public string PictureUrl { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("priceChangeNum")]
        public int PriceChangeNum { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("priceChangeNumMax")]
        public int PriceChangeNumMax { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("priceChangeSingle")]
        public string PriceChangeSingle { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("startDate")]
        public string StartDate { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("endDate")]
        public string EndDate { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("createDate")]
        public string CreateDate { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("valid")]
        public bool Valid { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("movieIds")]
        public string MovieIds { get; set; }
    }

}
