﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace CinemaWin.Iqiyi.Model.Cinema
{
    public class IqiyiH5Session
    {
        /// <summary>
        /// Examples: "80"
        /// </summary>
        [JsonProperty("plusPromotionPrice")]
        public string PlusPromotionPrice { get; set; }

        /// <summary>
        /// Examples: "33"
        /// </summary>
        [JsonProperty("priceString")]
        public string PriceString { get; set; }

        /// <summary>
        /// Examples: 80.0
        /// </summary>
        [JsonProperty("originalPrice")]
        public double OriginalPrice { get; set; }

        /// <summary>
        /// Examples: "购礼包立减5元"
        /// </summary>
        [JsonProperty("sessionTips")]
        public string SessionTips { get; set; }

        /// <summary>
        /// Examples: "8号厅", "7号厅", "情侣厅"
        /// </summary>
        [JsonProperty("hall")]
        public string Hall { get; set; }

        /// <summary>
        /// Examples: [{"areaId":"15000","price":33.0,"setAreaId":true,"setPrice":true}], [{"areaId":"14999","price":33.0,"setAreaId":true,"setPrice":true}], [{"areaId":"15000","price":33.0,"setAreaId":true,"setPrice":true}], [{"areaId":"14993","price":33.0,"setAreaId":true,"setPrice":true}], [{"areaId":"14999","price":33.0,"setAreaId":true,"setPrice":true}]
        /// </summary>
        [JsonProperty("areas")]
        public List<PriceArea> Areas { get; set; }

        /// <summary>
        /// Examples: "VIP专享0.0元"
        /// </summary>
        [JsonProperty("vipPriceTips")]
        public string VipPriceTips { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("isDiscount")]
        public bool IsDiscount { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("promotionTag")]
        public string PromotionTag { get; set; }

        /// <summary>
        /// Examples: "汉语 2D"
        /// </summary>
        [JsonProperty("type")]
        public string Type { get; set; }

        /// <summary>
        /// Examples: "33"
        /// </summary>
        [JsonProperty("movieEnablePrice")]
        public string MovieEnablePrice { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("hasDiffAreaPrice")]
        public bool HasDiffAreaPrice { get; set; }

        /// <summary>
        /// Examples: 128
        /// </summary>
        [JsonProperty("duration")]
        public int Duration { get; set; }

        /// <summary>
        /// Examples: 33.0
        /// </summary>
        [JsonProperty("price")]
        public double Price { get; set; }

        /// <summary>
        /// Examples: 0.0
        /// </summary>
        [JsonProperty("vipPrice")]
        public double VipPrice { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("promotionUse")]
        public bool PromotionUse { get; set; }

        /// <summary>
        /// Examples: "20210304163000", "20210304180500", "20210304185000", "20210304193000", "20210304202500"
        /// </summary>
        [JsonProperty("rawOutDateTime")]
        public string RawOutDateTime { get; set; }

        /// <summary>
        /// Examples: "16:30", "18:05", "18:50", "19:30", "20:25"
        /// </summary>
        [JsonProperty("startTime")]
        public string StartTime { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("disabled")]
        public bool Disabled { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("comparisonTips")]
        public string ComparisonTips { get; set; }

        /// <summary>
        /// Examples: "80"
        /// </summary>
        [JsonProperty("originalPriceString")]
        public string OriginalPriceString { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("thirdUpdateTime")]
        public string ThirdUpdateTime { get; set; }

        /// <summary>
        /// Examples: "maoyan"
        /// </summary>
        [JsonProperty("thirdFrom")]
        public string ThirdFrom { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("thirdCinemaId")]
        public string ThirdCinemaId { get; set; }

        /// <summary>
        /// Examples: "1630", "1805", "1850", "1930", "2025"
        /// </summary>
        [JsonProperty("rawStartTime")]
        public string RawStartTime { get; set; }

        /// <summary>
        /// Examples: 727383779, 727383787, 727383789, 727383791, 727383796
        /// </summary>
        [JsonProperty("sessionId")]
        public string SessionId { get; set; }

        /// <summary>
        /// Examples: "727383779", "727383787", "727383789", "727383791", "727383796"
        /// </summary>
        [JsonProperty("partnerSessionId")]
        public string PartnerSessionId { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("isVip")]
        public bool IsVip { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("isComparable")]
        public bool IsComparable { get; set; }

        /// <summary>
        /// Examples: [{"price":"33","vipPrice":"0","partnerId":8}], [{"price":"33","vipPrice":"0","partnerId":8}], [{"price":"33","vipPrice":"0","partnerId":8}], [{"price":"33","vipPrice":"0","partnerId":8}], [{"price":"33","vipPrice":"0","partnerId":8}]
        /// </summary>
        [JsonProperty("otherPartners")]
        public List<OtherPartner> OtherPartners { get; set; }

        /// <summary>
        /// Examples: {"bgColor":"#FFE351","content":"购票","colorFont":"#333333"}, {"bgColor":"#FFE351","content":"购票","colorFont":"#333333"}, {"bgColor":"#FFE351","content":"购票","colorFont":"#333333"}, {"bgColor":"#FFE351","content":"购票","colorFont":"#333333"}, {"bgColor":"#FFE351","content":"购票","colorFont":"#333333"}
        /// </summary>
        [JsonProperty("movieButton")]
        public MovieButton MovieButton { get; set; }

        /// <summary>
        /// Examples: "18:38", "20:13", "20:58", "21:38", "22:33"
        /// </summary>
        [JsonProperty("endTime")]
        public string EndTime { get; set; }

        /// <summary>
        /// Examples: 8
        /// </summary>
        [JsonProperty("partnerId")]
        public string PartnerId { get; set; }

        /// <summary>
        /// Examples: "D2"
        /// </summary>
        [JsonProperty("pureMovieType")]
        public string PureMovieType { get; set; }

        /// <summary>
        /// Examples: 33.0
        /// </summary>
        [JsonProperty("realPrice")]
        public double RealPrice { get; set; }

        /// <summary>
        /// Examples: "14205"
        /// </summary>
        [JsonProperty("partnerCinemaId")]
        public string PartnerCinemaId { get; set; }

        /// <summary>
        /// 电影id
        /// </summary>
        [JsonProperty("movieId")]
        public string MovieId { get; set; }

    }
    public class PriceArea
    {
        /// <summary>
        /// Examples: "15000", "14999", "14993"
        /// </summary>
        [JsonProperty("areaId")]
        public string AreaId { get; set; }

        /// <summary>
        /// Examples: 33.0
        /// </summary>
        [JsonProperty("price")]
        public double Price { get; set; }

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("setAreaId")]
        public bool SetAreaId { get; set; }

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("setPrice")]
        public bool SetPrice { get; set; }
    }
    public class OtherPartner
    {

        /// <summary>
        /// Examples: "33"
        /// </summary>
        [JsonProperty("price")]
        public string Price { get; set; }

        /// <summary>
        /// Examples: "0"
        /// </summary>
        [JsonProperty("vipPrice")]
        public string VipPrice { get; set; }

        /// <summary>
        /// Examples: 8
        /// </summary>
        [JsonProperty("partnerId")]
        public string PartnerId { get; set; }
    }
    public class MovieButton
    {
        /// <summary>
        /// Examples: "#FFE351"
        /// </summary>
        [JsonProperty("bgColor")]
        public string BgColor { get; set; }

        /// <summary>
        /// Examples: "购票"
        /// </summary>
        [JsonProperty("content")]
        public string Content { get; set; }

        /// <summary>
        /// Examples: "#333333"
        /// </summary>
        [JsonProperty("colorFont")]
        public string ColorFont { get; set; }
    }
}
