﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace iqiyiWin.Model
{
    public class IqiyiTask
    {
        /// <summary>
        /// Examples: "观影豆"
        /// </summary>
        [JsonProperty("rewardName")]
        public string RewardName { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("receive")]
        public bool Receive { get; set; }

        /// <summary>
        /// Examples: "qyticket://movieticketroot", "https://app.iqiyi.com/ext/common/qipiao/libao_goumai/app.html?channel=piaoapp_flrw", ""
        /// </summary>
        [JsonProperty("ladingPage")]
        public string LadingPage { get; set; }

        /// <summary>
        /// Examples: 25, 200, 50
        /// </summary>
        [JsonProperty("rewardCount")]
        public int RewardCount { get; set; }

        /// <summary>
        /// Examples: "首次标记\"想看\"电影", "首次体验在线选座", "首次购买超值礼包", "首次购买电影票", "完成全部新手任务"
        /// </summary>
        [JsonProperty("taskName")]
        public string TaskName { get; set; }

        /// <summary>
        /// Examples: "在电影列表中挑选自己想看的电影，在影片介绍页点击\"想看\"", "在电影列表中挑选想看的电影，体验在线选择座位并确认", "", "1.完成首次购买电影票，在所购买场次观影日期结束后记做任务完成;\r\n2.每位用户仅限赠送1次。同一爱奇艺账号、手机号、设备、支付账号均视为同一用户。"
        /// </summary>
        [JsonProperty("remark")]
        public string Remark { get; set; }

        /// <summary>
        /// Examples: false, true
        /// </summary>
        [JsonProperty("complete")]
        public bool Complete { get; set; }

        /// <summary>
        /// Examples: 30803720, 31926773
        /// </summary>
        [JsonProperty("recordId")]
        public string RecordId { get; set; }
    }
}
