﻿using iqiyiWin.Qianzhu.Model.User;
using iqiyiWin.Qianzhu.Request.User;
using iqiyiWin.Qianzhu.Response;
using iqiyiWin.Qianzhu.Response.User;
using iqiyiWin.Util;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace iqiyiWin.Qianzhu.Api
{
    public class QianzhuUserApi
    {

        /// <summary>
        /// 登录
        /// </summary>
        /// <param name="mobile">手机号</param>
        /// <param name="password">密码</param>
        /// <returns>token</returns>
        public static QianzhuUserLoginResponse Login(string mobile, string password)
        {
            QianzhuUserLoginRequest request = new QianzhuUserLoginRequest();
            request.Mobile = mobile;
            request.Password = password;

            var responseStr = HttpUtils.DoPost(App.Instance.GetQianzhuDomain() + "/admin/login/mobile", JsonConvert.SerializeObject(request), null);
            UILogUtils.Debug("千猪 【登录】响应:" + responseStr);

            var response = JsonConvert.DeserializeObject<QianzhuUserLoginResponse>(responseStr);
            return response;
        }

        /// <summary>
        /// 获取用户信息
        /// </summary>
        /// <param name="token">token</param>
        /// <returns>用户信息</returns>
        public static QianzhuUser GetUser(string token)
        {
            Dictionary<string, string> headers = new Dictionary<string, string>();
            headers.Add("Authorization", token);

            var responseStr = HttpUtils.DoGet(App.Instance.GetQianzhuDomain() + "/admin/user/userInfo", headers);
            UILogUtils.Debug("千猪 【用户信息】响应:" + responseStr);
            var response = JsonConvert.DeserializeObject<QianzhuGetUserResponse>(responseStr);

            if (response != null && response.Success)
            {
                UILogUtils.Info("千猪 【用户信息】成功。");
                return response.Data.User;
            }
            else
            {
                UILogUtils.Error("千猪 【用户信息】失败:" + (response == null ? responseStr : response.Message));
                return null;
            }
        }
    }
}
