﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace iqiyiWin.Qianzhu.Response.User
{
    public class QianzhuUserLoginResponse: QianzhuBaseResponse<QianzhuUserLoginResponseData>
    {

    }

    public class QianzhuUserLoginResponseData
    {
        /// <summary>
        /// Examples: 1001080
        /// </summary>
        [JsonProperty("userId")]
        public int UserId { get; set; }

        /// <summary>
        /// Examples: "eyJhbGciOiJIUzI1NiJ9.eyJleHAiOjE2MDkxMjE1OTIsInVzZXJJZCI6MTAwMTA4MCwidXNlck5hbWUiOiLpm6jlpJwiLCJ0b2tlblR5cGUiOjB9.1cdGJ-UDq_a7-Ydop6Q78msLNy10ki3pZgF_9Q9LoU0"
        /// </summary>
        [JsonProperty("accessToken")]
        public string AccessToken { get; set; }

        /// <summary>
        /// Examples: 604800
        /// </summary>
        [JsonProperty("accessTokenExpireIn")]
        public int AccessTokenExpireIn { get; set; }

        /// <summary>
        /// Examples: "eyJhbGciOiJIUzI1NiJ9.eyJleHAiOjE2MTExMDg3OTIsInVzZXJJZCI6MTAwMTA4MCwidXNlck5hbWUiOiLpm6jlpJwiLCJ0b2tlblR5cGUiOjF9.G23BaKzNLXbqtsaaRUHaYOBP86_WjB5--_Qk2EJCL40"
        /// </summary>
        [JsonProperty("refreshToken")]
        public string RefreshToken { get; set; }

        /// <summary>
        /// Examples: ["user","admin","supplier","platform","sxKfc"]
        /// </summary>
        [JsonProperty("roles")]
        public List<string> Roles { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("newUser")]
        public bool NewUser { get; set; }
    }
}
