﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using iqiyiWin.Constant;
using iqiyiWin.Util;
using Newtonsoft.Json;

namespace iqiyiWin.Request.FilmTask
{
    public class GetTaskListRequest
    {
        /// <summary>
        /// 设备随机码
        /// </summary>
        [JsonProperty("dfp")]
        public string Dfp { get; set; } = IqiyiVersion.Dfp();
        [JsonProperty("deviceId")]
        public string DeviceId { get { return Dfp; } }
        /// <summary>
        /// Appid
        /// </summary>
        [JsonProperty("appid")]
        public string Appid { get; set; } = IqiyiVersion.Appid;
        /// <summary>
        /// 手机系统
        /// </summary>
        [JsonProperty("os")]
        public string Os { get; set; } = IqiyiVersion.Os;
        /// <summary>
        /// 数据格式
        /// </summary>
        [JsonProperty("format")]
        public string Format { get; set; } = "json";
        /// <summary>
        /// 平台
        /// </summary>
        [JsonProperty("platform")]
        public string Platform { get; set; } = IqiyiVersion.Platform;
        /// <summary>
        /// 时间
        /// </summary>
        [JsonProperty("ts")]
        public string Ts { get; set; } = DateUtils.GetTimeStampOfMilliseconds().ToString();
        /// <summary>
        /// 来源
        /// </summary>
        [JsonProperty("src")]
        public string Src { get; set; } = IqiyiVersion.Src;
        /// <summary>
        /// 版本
        /// </summary>
        [JsonProperty("version")]
        public string Version { get; set; } = IqiyiVersion.Version;
        /// <summary>
        /// cookie
        /// </summary>
        [JsonProperty("ck")]
        public string Ck { get; set; }
        /// <summary>
        /// 请求随机码
        /// </summary>
        [JsonProperty("nonce")]
        public string Nonce { get; set; } = IqiyiVersion.Nonce(0);
        /// <summary>
        /// 类型
        /// </summary>
        [JsonProperty("bizType")]
        public string BizType { get; set; } = IqiyiVersion.BizType;
        /// <summary>
        /// 时间戳
        /// </summary>
        [JsonProperty("_t")]
        public string T { get; set; } = DateUtils.GetTimeStampOfMilliseconds().ToString();
    }
}
