﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using iqiyiWin.Constant;
using iqiyiWin.Util;
using Newtonsoft.Json;

namespace iqiyiWin.Request
{
    public class IqiyiH5BaseRequest
    {
        /// <summary>
        /// 版本
        /// </summary>
        [JsonProperty("version")]
        public string Version { get; set; } = IqiyiVersion.Version;

        /// <summary>
        /// 手机系统
        /// </summary>
        [JsonProperty("os")]
        public string Os { get; set; } = IqiyiVersion.Os;

        /// <summary>
        /// 来源
        /// </summary>
        [JsonProperty("src")]
        public string Src { get; set; } = IqiyiVersion.Src;

        /// <summary>
        /// 平台
        /// </summary>
        [JsonProperty("platform")]
        public string Platform { get; set; } = IqiyiVersion.Platform;

        /// <summary>
        /// Appid
        /// </summary>
        [JsonProperty("appid")]
        public string Appid { get; set; } = IqiyiVersion.Appid;

        /// <summary>
        /// 系统
        /// </summary>
        [JsonProperty("dvsrc")]
        public string Dvsrc { get; set; } = IqiyiVersion.Dvsrc;

        /// <summary>
        /// 设备随机码
        /// </summary>
        [JsonProperty("dfp")]
        public string Dfp { get; set; } = IqiyiVersion.Dfp();

        /// <summary>
        /// 系统
        /// </summary>
        [JsonProperty("ts")]
        public string Ts { get; set; } = DateUtils.GetTimeStampOfMilliseconds().ToString();

        /// <summary>
        /// 请求随机码
        /// </summary>
        [JsonProperty("nonce")]
        public string Nonce { get; set; } = IqiyiVersion.Nonce(1);

        /// <summary>
        /// 签名
        /// </summary>
        [JsonProperty("sig")]
        public string Sig { get; set; } = "";
    }
}