﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using iqiyiWin.Request;
using Newtonsoft.Json;

namespace CinemaWin.Iqiyi.Request.Order
{
    public class IqiyiH5CreateOrderRequest: IqiyiH5BaseRequest
    {
        /// <summary>
        /// 电影id
        /// </summary>
        [JsonProperty("movieIds")]
        public string MovieIds { get; set; }
        /// <summary>
        /// sessionId
        /// </summary>
        [JsonProperty("sessionId")]
        public string SessionId { get; set; }
        /// <summary>
        /// {row}:{column}|{row}:{column}
        /// </summary>
        [JsonProperty("seatInfo")]
        public string SeatInfo { get; set; }
        /// <summary>
        /// ?partnerId
        /// </summary>
        [JsonProperty("partnerId")]
        public string PartnerId { get; set; }
        /// <summary>
        /// sessionId
        /// </summary>
        [JsonProperty("seqNo")]
        public string SeqNo { get; set; }
        /// <summary>
        /// 选座数量
        /// </summary>
        [JsonProperty("seatNum")]
        public string SeatNum { get; set; }
        /// <summary>
        /// partnerSeatId,partnerSeatId
        /// </summary>
        [JsonProperty("seatId")]
        public string SeatId { get; set; }
        /// <summary>
        /// thirdUpdateTime
        /// </summary>
        [JsonProperty("thirdUpdateTime")]
        public string thirdUpdateTime { get; set; } = "";
        /// <summary>
        /// gway
        /// </summary>
        [JsonProperty("gway")]
        public string Gway { get; set; } = "h5:border";
        /// <summary>
        /// gateway
        /// </summary>
        [JsonProperty("gateway")]
        public string Gateway { get; set; } = "h5";
        /// <summary>
        /// mkey
        /// </summary>
        [JsonProperty("mkey")]
        public string mMkey { get; set; } = "";
        /// <summary>
        /// inittype
        /// </summary>
        [JsonProperty("inittype")]
        public string Inittype { get; set; } = "h5";
        /// <summary>
        /// ?aid
        /// </summary>
        [JsonProperty("areaId")]
        public string AreaId { get; set; }

        [JsonProperty("ck")]
        public string Ck { get; set; }
    }
}
