﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using iqiyiWin.Model;
using Newtonsoft.Json;

namespace iqiyiWin.Response.Cinema.CinemaItem
{
    public class CinemaResponse
    {
        /// <summary>
        /// </summary>
        [JsonProperty("data")]
        public CinemaData Data { get; set; }

        /// <summary>
        /// Examples: "20210513124535"
        /// </summary>
        [JsonProperty("timestamp")]
        public string Timestamp { get; set; }

        /// <summary>
        /// Examples: "A00000"
        /// </summary>
        [JsonProperty("code")]
        public string Code { get; set; }

        /// <summary>
        /// Examples: "c166ba49-adcb-4651-8ec0-cfa22665cbfb"
        /// </summary>
        [JsonProperty("requestId")]
        public string RequestId { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("msg")]
        public string Msg { get; set; }

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("hasNext")]
        public bool HasNext { get; set; }
    }
    public class CinemaData{
        /// <summary>
        /// Examples: [{"cinemaPrice":15.1,"cinemaPriceString":"15.1","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市闵行区永跃路360号万达广场4F-A室","tags":[],"sessionTotalCount":249,"areaId":1401256098,"cinemaId":382548827,"cinemaName":"万达影城（上海浦江万达广场店）","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":19.9,"cinemaPriceString":"19.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"通河路533弄2号红太阳商业广场3楼（从一楼爱婴室旁手扶梯电梯至三楼）","tags":[{"name":"4K","field":"k4","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"}],"sessionTotalCount":243,"areaId":1401255798,"cinemaId":382413427,"cinemaName":"大光明RGB全激光影城（红太阳店）","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":44.9,"cinemaPriceString":"44.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市闵行区漕宝路3366号上海七宝万科广场5层L501单元","tags":[],"sessionTotalCount":241,"areaId":1401256098,"cinemaId":381227327,"cinemaName":"CGV影城（七宝万科广场店）","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":19.9,"cinemaPriceString":"19.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海南汇区惠南镇南门大街18号乐购广场5层","tags":[],"sessionTotalCount":239,"areaId":1401257098,"cinemaId":180457627,"cinemaName":"大地影院（上海南汇店）","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":22.8,"cinemaPriceString":"22.8","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市闵行区都市路2700号4F-A，5F-A","tags":[],"sessionTotalCount":239,"areaId":1401256098,"cinemaId":381934427,"cinemaName":"万达国际影城（颛桥万达广场店）","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":27.9,"cinemaPriceString":"27.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市闵行区剑川路1000弄龙湖天街4F","tags":[],"sessionTotalCount":235,"areaId":1401256098,"cinemaId":2628396670831127,"cinemaName":"星轶STARX影城（龙湖闵行天街旗舰店）","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":40.9,"cinemaPriceString":"40.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市闵行区都市路5001号仲盛世界商城4层近莘庄地铁南广场","tags":[{"name":"4K","field":"k4","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"},{"name":"REALD","field":"reald","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"},{"name":"4D","field":"d4","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"}],"sessionTotalCount":234,"areaId":1401256098,"cinemaId":180474327,"cinemaName":"上影CGV（莘庄店）","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":19.9,"cinemaPriceString":"19.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市普陀区金沙江路1685号118广场T座5、6楼","tags":[],"sessionTotalCount":232,"areaId":1401256398,"cinemaId":381902227,"cinemaName":"泰禾影城上海中环118广场店","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":19.9,"cinemaPriceString":"19.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市闵行区东川路2088号置业广场3楼","tags":[{"name":"商场","field":"shopping","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"}],"sessionTotalCount":231,"areaId":1401256098,"cinemaId":381762227,"cinemaName":"SFC上影国际影城（东川店）","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":15.0,"cinemaPriceString":"15","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"沪闵路7866号莲花国际广场B1层（地铁1号线莲花路站对面）","tags":[],"sessionTotalCount":229,"areaId":1401256098,"cinemaId":381354427,"cinemaName":"CMC大光明影城（莲花店）","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":39.9,"cinemaPriceString":"39.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市静安区万荣路777号大宁音乐广场A座","tags":[],"sessionTotalCount":228,"areaId":1401257398,"cinemaId":381090927,"cinemaName":"海上明珠影城上海大宁IMAX店","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":33.9,"cinemaPriceString":"33.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市浦东新区永泰路1058弄5号商场三林印象城4楼","tags":[],"sessionTotalCount":224,"areaId":1401257098,"cinemaId":382034227,"cinemaName":"CGV影城（上海浦东印象城）","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":23.9,"cinemaPriceString":"23.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市浦东新区华夏东路2255号浦商百货3楼","tags":[],"sessionTotalCount":222,"areaId":1401257098,"cinemaId":1123533540545927,"cinemaName":"大光明丽星VIP影城（川沙金汇广场店）","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":19.9,"cinemaPriceString":"19.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市杨浦区翔殷路1099号合生汇4楼","tags":[{"name":"杜比全景声","field":"dolby","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"}],"sessionTotalCount":221,"areaId":1401256698,"cinemaId":381038327,"cinemaName":"上海中影国际影城（合生汇店）","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":15.1,"cinemaPriceString":"15.1","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市浦东新区年家浜路518号万达广场四层","tags":[{"name":"4K","field":"k4","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"},{"name":"REALD","field":"reald","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"},{"name":"IMAX","field":"imax","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"}],"sessionTotalCount":221,"areaId":1401257098,"cinemaId":380932327,"cinemaName":"上海周浦万达广场店","cinemaDistance":0.0,"hasImx":true,"order":0},{"cinemaPrice":23.9,"cinemaPriceString":"23.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市闵行区鹤庆路900号碧江生活广场4号楼3层","tags":[{"name":"巨幕","field":"jumu","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"}],"sessionTotalCount":221,"areaId":1401256098,"cinemaId":180678927,"cinemaName":"保利国际影城上海江川店","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":23.9,"cinemaPriceString":"23.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市浦东新区昌里路337号4楼","tags":[],"sessionTotalCount":221,"areaId":1401257098,"cinemaId":381711427,"cinemaName":"上海大光明丽星VIP影城","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":43.9,"cinemaPriceString":"43.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"东长治路588号上海白玉兰广场商业裙房3层11号铺位","tags":[],"sessionTotalCount":221,"areaId":1401256898,"cinemaId":381699027,"cinemaName":"CGV影城(白玉兰广场IMAX店)","cinemaDistance":0.0,"hasImx":true,"order":0},{"cinemaPrice":23.9,"cinemaPriceString":"23.9","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"博山东路88号4层01号","tags":[],"sessionTotalCount":221,"areaId":1401257098,"cinemaId":382143427,"cinemaName":"大光明丽星VIP影城(博山路店)","cinemaDistance":0.0,"hasImx":false,"order":0},{"cinemaPrice":15.1,"cinemaPriceString":"15.1","seatStatus":0,"cinemaDistanceString":"","movieId":0,"isStored":false,"cinemaAddress":"上海市杨浦区国宾路58号万达广场三层","tags":[{"name":"REALD","field":"reald","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"},{"name":"IMAX","field":"imax","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"},{"name":"商场","field":"shopping","type":"common","wireframe":"#EF7D52","background":"#FFFFFF","colorFont":"#EF7D52"}],"sessionTotalCount":221,"areaId":1401256698,"cinemaId":380947727,"cinemaName":"上海五角场万达广场店","cinemaDistance":0.0,"hasImx":true,"order":0}]
        /// </summary>
        [JsonProperty("cinemas")]
        public List<IqiyiCinema> Cinemas { get; set; }
    }
}
