﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CinemaWin.Iqiyi.Model.Cinema;
using Newtonsoft.Json;

namespace CinemaWin.Iqiyi.Response
{
    public class IqiyiCitiesResponse
    {
        /// <summary>
        /// Examples: {"pinyin":"shanghai","initial":"S","name":"上海","cityId":1400254893,"isHotCity":true}
        /// </summary>
        [JsonProperty("defaultCity")]
        public IqiyiH5City DefaultCity { get; set; }

        /// <summary>
        /// Examples: [{"pinyin":"beijing","initial":"B","name":"北京","cityId":1400249193,"isHotCity":true},{"pinyin":"chongqing","initial":"C","name":"重庆","cityId":1400249593,"isHotCity":true},{"pinyin":"shanghai","initial":"S","name":"上海","cityId":1400254893,"isHotCity":true},{"pinyin":"guangzhou","initial":"G","name":"广州","cityId":1400250993,"isHotCity":true},{"pinyin":"shenzhen","initial":"S","name":"深圳","cityId":1400254993,"isHotCity":true},{"pinyin":"nanjing","initial":"N","name":"南京","cityId":1400253693,"isHotCity":true},{"pinyin":"hangzhou","initial":"H","name":"杭州","cityId":1400251193,"isHotCity":true},{"pinyin":"chengdu","initial":"C","name":"成都","cityId":1400249693,"isHotCity":true}]
        /// </summary>
        [JsonProperty("hotCities")]
        public List<IqiyiH5City> HotCities { get; set; }

        /// <summary>
        /// Examples: 
        /// </summary>
        [JsonProperty("cities")]
        public List<City> Cities { get; set; }

        /// <summary>
        /// Examples: {"pinyin":"shanghai","initial":"S","name":"上海","cityId":1400254893,"isHotCity":true}
        /// </summary>
        [JsonProperty("currentCity")]
        public IqiyiH5City CurrentCity { get; set; }
        
    }
    public class City
    {

        /// <summary>
        /// Examples: [{"pinyin":"akesu","initial":"A","name":"阿克苏","cityId":1401542293,"isHotCity":false},{"pinyin":"anshan","initial":"A","name":"鞍山","cityId":1401269893,"isHotCity":false},{"pinyin":"alashan","initial":"A","name":"阿盟,阿拉善","cityId":1401292393,"isHotCity":false},{"pinyin":"anqing","initial":"A","name":"安庆","cityId":1401280593,"isHotCity":false},{"pinyin":"anshun","initial":"A","name":"安顺","cityId":1401273993,"isHotCity":false},{"pinyin":"ankang","initial":"A","name":"安康","cityId":1401275593,"isHotCity":false},{"pinyin":"anyang","initial":"A","name":"安阳","cityId":1401264193,"isHotCity":false},{"pinyin":"aba","initial":"A","name":"阿坝","cityId":1401271193,"isHotCity":false}], [{"pinyin":"beijing","initial":"B","name":"北京","cityId":1400249193,"isHotCity":true},{"pinyin":"baiyin","initial":"B","name":"白银","cityId":1401280793,"isHotCity":false},{"pinyin":"binzhou","initial":"B","name":"滨州","cityId":1401271693,"isHotCity":false},{"pinyin":"baicheng","initial":"B","name":"白城","cityId":1401280893,"isHotCity":false},{"pinyin":"baishan","initial":"B","name":"白山","cityId":1400249293,"isHotCity":false},{"pinyin":"bayinguoleng","initial":"B","name":"巴音郭楞","cityId":1401292493,"isHotCity":false},{"pinyin":"baise","initial":"B","name":"百色","cityId":1401275493,"isHotCity":false},{"pinyin":"beihai","initial":"B","name":"北海","cityId":1401274593,"isHotCity":false},{"pinyin":"benxi","initial":"B","name":"本溪","cityId":1401281393,"isHotCity":false},{"pinyin":"bayannaoer","initial":"B","name":"巴彦淖尔","cityId":1401281193,"isHotCity":false},{"pinyin":"baotou","initial":"B","name":"包头","cityId":1400249493,"isHotCity":false},{"pinyin":"bengbu","initial":"B","name":"蚌埠","cityId":1400249393,"isHotCity":false},{"pinyin":"bozhou","initial":"B","name":"亳州","cityId":1401265893,"isHotCity":false},{"pinyin":"bijie","initial":"B","name":"毕节","cityId":1401273293,"isHotCity":false},{"pinyin":"baoding","initial":"B","name":"保定","cityId":1401268393,"isHotCity":false},{"pinyin":"baoji","initial":"B","name":"宝鸡","cityId":1401268893,"isHotCity":false},{"pinyin":"baoshan","initial":"B","name":"保山","cityId":1401268693,"isHotCity":false},{"pinyin":"bazhong","initial":"B","name":"巴中","cityId":1401281493,"isHotCity":false}], [{"pinyin":"chongqing","initial":"C","name":"重庆","cityId":1400249593,"isHotCity":true},{"pinyin":"chaozhou","initial":"C","name":"潮州","cityId":1401260793,"isHotCity":false},{"pinyin":"changchun","initial":"C","name":"长春","cityId":1400249893,"isHotCity":false},{"pinyin":"changzhi","initial":"C","name":"长治","cityId":1401282193,"isHotCity":false},{"pinyin":"changji","initial":"C","name":"昌吉","cityId":1401292793,"isHotCity":false},{"pinyin":"chongzuo","initial":"C","name":"崇左","cityId":1401281793,"isHotCity":false},{"pinyin":"changzhou","initial":"C","name":"常州","cityId":1400249793,"isHotCity":false},{"pinyin":"chengmai","initial":"C","name":"澄迈","cityId":1401420593,"isHotCity":false},{"pinyin":"chifeng","initial":"C","name":"赤峰","cityId":1401264393,"isHotCity":false},{"pinyin":"chuzhou","initial":"C","name":"滁州","cityId":1401263393,"isHotCity":false},{"pinyin":"chizhou","initial":"C","name":"池州","cityId":1401275793,"isHotCity":false},{"pinyin":"cangzhou","initial":"C","name":"沧州","cityId":1401262393,"isHotCity":false},{"pinyin":"chengde","initial":"C","name":"承德","cityId":1401279393,"isHotCity":false},{"pinyin":"changsha","initial":"C","name":"长沙","cityId":1400249993,"isHotCity":false},{"pinyin":"changde","initial":"C","name":"常德","cityId":1401281893,"isHotCity":false},{"pinyin":"chenzhou","initial":"C","name":"郴州","cityId":1401263893,"isHotCity":false},{"pinyin":"chuxiong","initial":"C","name":"楚雄","cityId":1401270293,"isHotCity":false},{"pinyin":"chengdu","initial":"C","name":"成都","cityId":1400249693,"isHotCity":true}], [{"pinyin":"daxinganling","initial":"D","name":"大兴安岭","cityId":1401540693,"isHotCity":false},{"pinyin":"daqing","initial":"D","name":"大庆","cityId":1400250293,"isHotCity":false},{"pinyin":"dingxi","initial":"D","name":"定西","cityId":1401282693,"isHotCity":false},{"pinyin":"dongguan","initial":"D","name":"东莞","cityId":1400250493,"isHotCity":false},{"pinyin":"dongying","initial":"D","name":"东营","cityId":1400250593,"isHotCity":false},{"pinyin":"dezhou","initial":"D","name":"德州","cityId":1401266393,"isHotCity":false},{"pinyin":"datong","initial":"D","name":"大同","cityId":1400250393,"isHotCity":false},{"pinyin":"dalian","initial":"D","name":"大连","cityId":1400250193,"isHotCity":false},{"pinyin":"dandong","initial":"D","name":"丹东","cityId":1401265793,"isHotCity":false},{"pinyin":"danzhou","initial":"D","name":"儋州","cityId":1401270693,"isHotCity":false},{"pinyin":"dongfang","initial":"D","name":"东方","cityId":1401295893,"isHotCity":false},{"pinyin":"dingan","initial":"D","name":"定安","cityId":1401376393,"isHotCity":false},{"pinyin":"dali","initial":"D","name":"大理","cityId":1400250093,"isHotCity":false},{"pinyin":"diqing","initial":"D","name":"迪庆","cityId":1401293093,"isHotCity":false},{"pinyin":"dehong","initial":"D","name":"德宏","cityId":1401293193,"isHotCity":false},{"pinyin":"deyang","initial":"D","name":"德阳","cityId":1401266493,"isHotCity":false},{"pinyin":"dazhou","initial":"D","name":"达州","cityId":1401262993,"isHotCity":false}], [{"pinyin":"ezhou","initial":"E","name":"鄂州","cityId":1401282793,"isHotCity":false},{"pinyin":"enshi","initial":"E","name":"恩施","cityId":1401291093,"isHotCity":false},{"pinyin":"eerduosi","initial":"E","name":"鄂尔多斯","cityId":1401264593,"isHotCity":false}]
        /// </summary>
        [JsonProperty("value")]
        public IList<IqiyiH5City> Value { get; set; }

        /// <summary>
        /// Examples: "A", "B", "C", "D", "E"
        /// </summary>
        [JsonProperty("key")]
        public string Key { get; set; }
    }
}
