﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CinemaWin.Iqiyi.Model.Cinema;
using Newtonsoft.Json;

namespace CinemaWin.Iqiyi.Response.Cinema
{
    public class IqiyiH5MoviesResponse
    {

        [JsonProperty("cinemaInfo")]
        public CinemaInfo CinemaInfo { get; set; }
    }
    public class CinemaInfo
    {

        /// <summary>
        /// Examples: 120.337071870656
        /// </summary>
        [JsonProperty("gaodeLng")]
        public double GaodeLng { get; set; }

        /// <summary>
        /// Examples: "下沙文渊路499号四季广场5幢2层"
        /// </summary>
        [JsonProperty("address")]
        public string Address { get; set; }

        /// <summary>
        /// Examples: 1745301399
        /// </summary>
        [JsonProperty("selectedMovieId")]
        public int SelectedMovieId { get; set; }

        /// <summary>
        /// Examples: 30.320651651037
        /// </summary>
        [JsonProperty("gaodeLat")]
        public double GaodeLat { get; set; }

        /// <summary>
        /// Examples: "0571-86939088"
        /// </summary>
        [JsonProperty("cinemaPhone")]
        public string CinemaPhone { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("isStored")]
        public bool IsStored { get; set; }

        /// <summary>
        /// Examples: []
        /// </summary>
        [JsonProperty("tags")]
        public IList<object> Tags { get; set; }

        /// <summary>
        /// Examples: "开场前15分钟不可购票"
        /// </summary>
        [JsonProperty("noticeTip")]
        public string NoticeTip { get; set; }

        /// <summary>
        /// Examples: 30.326777985079
        /// </summary>
        [JsonProperty("baiduLat")]
        public double BaiduLat { get; set; }

        /// <summary>
        /// Examples
        /// </summary>
        [JsonProperty("movies")]
        public List<IqiyiH5Movie> Movies { get; set; }

        /// <summary>
        /// Examples: "https://map.baidu.com/mobile/webapp/place/marker/qt=inf&vt=map&act=read_share/point=13396725.336667840000,3523850.839685033000&title=四季国际影城&content=下沙文渊路499号四季广场5幢2层"
        /// </summary>
        [JsonProperty("locationUrl")]
        public string LocationUrl { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("isHasImx")]
        public bool IsHasImx { get; set; }

        /// <summary>
        /// Examples: 381779027
        /// </summary>
        [JsonProperty("cinemaId")]
        public string CinemaId { get; set; }

        /// <summary>
        /// Examples: "四季国际影城"
        /// </summary>
        [JsonProperty("name")]
        public string Name { get; set; }

        /// <summary>
        /// Examples: 120.34352183608
        /// </summary>
        [JsonProperty("baiduLng")]
        public double BaiduLng { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("notice")]
        public string Notice { get; set; }
    }
}
