﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CinemaWin.Iqiyi.Model.Cinema;
using Newtonsoft.Json;

namespace CinemaWin.Iqiyi.Response.Cinema
{
    public class IqiyiH5SeatMapResponse
    {

        /// <summary>
        /// Examples: "20210305"
        /// </summary>
        [JsonProperty("date")]
        public string Date { get; set; }

        /// <summary>
        /// Examples: {}
        /// </summary>
        [JsonProperty("priceChangeInfo")]
        public PriceChangeInfo PriceChangeInfo { get; set; }

        /// <summary>
        /// Examples: 5
        /// </summary>
        [JsonProperty("maxSelectNum")]
        public int MaxSelectNum { get; set; }

        /// <summary>
        /// Examples: "https://pic2.iqiyipic.com/lequ/20210128/7399364f52004fa4a430593d8d94aec5.png"
        /// </summary>
        [JsonProperty("soldIcon")]
        public string SoldIcon { get; set; }

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("isToday")]
        public bool IsToday { get; set; }

        /// <summary>
        /// Examples: "1号激光厅"
        /// </summary>
        [JsonProperty("hall")]
        public string Hall { get; set; }

        /// <summary>
        /// Examples: 1745301399
        /// </summary>
        [JsonProperty("movieId")]
        public int MovieId { get; set; }

        /// <summary>
        /// Examples: ["2D"]
        /// </summary>
        [JsonProperty("type")]
        public List<string> Type { get; set; }

        /// <summary>
        /// Examples: 
        /// </summary>
        [JsonProperty("seats")]
        public Dictionary<int , List<IqiyiH5Seat>> Seats { get; set; }

        /// <summary>
        /// Examples: {"0":4400,"1":4400,"2":4400}
        /// </summary>
        [JsonProperty("areaPrice")]
        public Dictionary<string, string> AreaPrice { get; set; }



        /// <summary>
        /// Examples: [{"areaPrice":"¥44","hasDiscount":false,"aid":"0"},{"areaPrice":"¥44","hasDiscount":false,"aid":"1"},{"areaPrice":"¥44","hasDiscount":false,"aid":"2"}]
        ///// </summary>
        [JsonProperty("areaDiscountDisplay")]

        public List<AreaDiscountDisplay> AreaDiscountDisplay { get; set; }


        /// <summary>
        /// Examples: "https://pic1.iqiyipic.com/lequ/20210128/bf80ce30aec3493db570e6f7f7a65780.png"
        /// </summary>
        [JsonProperty("selectedIcon")]
        public string SelectedIcon { get; set; }

        /// <summary>
        /// Examples: {}
        /// </summary>
        [JsonProperty("areaPriceChangeInfo")]
        public AreaPriceChangeInfo AreaPriceChangeInfo { get; set; }

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("hasUnableSeat")]
        public bool HasUnableSeat { get; set; }

        /// <summary>
        /// Examples: 380949427
        /// </summary>
        [JsonProperty("cinemaId")]
        public string CinemaId { get; set; }

        /// <summary>
        /// Examples: 4400
        /// </summary>
        [JsonProperty("price")]
        public string Price { get; set; }

        /// <summary>
        /// Examples: "大地影院（杭州萧山宝龙店）"
        /// </summary>
        [JsonProperty("cinemaName")]
        public string CinemaName { get; set; }

        /// <summary>
        /// Examples: "汉语"
        /// </summary>
        [JsonProperty("lan")]
        public string Lan { get; set; }

        /// <summary>
        /// Examples: "2D"
        /// </summary>
        [JsonProperty("sessionType")]
        public string SessionType { get; set; }

        /// <summary>
        /// Examples: "今天10:30"
        /// </summary>
        [JsonProperty("playTime")]
        public string PlayTime { get; set; }

        /// <summary>
        /// Examples: "你选的是今天03-05的场次，请仔细核对哦"
        /// </summary>
        [JsonProperty("playTimeNotice")]
        public string PlayTimeNotice { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("disabled")]
        public bool Disabled { get; set; }

        /// <summary>
        /// Examples: "你好，李焕英"
        /// </summary>
        [JsonProperty("movieName")]
        public string MovieName { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("thirdUpdateTime")]
        public string ThirdUpdateTime { get; set; }

        /// <summary>
        /// Examples: 8
        /// </summary>
        [JsonProperty("rowSize")]
        public int RowSize { get; set; }

        /// <summary>
        /// Examples: "已超过特价限购数量\n超出部分恢复成原价"
        /// </summary>
        [JsonProperty("overSubmitTips")]
        public string OverSubmitTips { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("isPriceChange")]
        public bool IsPriceChange { get; set; }

        /// <summary>
        /// Examples: "1"
        /// </summary>
        [JsonProperty("supportArea")]
        public string SupportArea { get; set; }

        /// <summary>
        /// Examples: {"0":"FF2092","1":"08BF8B","2":"FFD527"}
        /// </summary>
        [JsonProperty("areaColor")]
        public Dictionary<string, string> AreaColor { get; set; }

        /// <summary>
        /// Examples: "12:38"
        /// </summary>
        [JsonProperty("playEndTime")]
        public string PlayEndTime { get; set; }

        /// <summary>
        /// Examples: "dadiv3"
        /// </summary>
        [JsonProperty("thirdFrom")]
        public string ThirdFrom { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("thirdCinemaId")]
        public string ThirdCinemaId { get; set; }

        /// <summary>
        /// Examples: 
        /// </summary>
        [JsonProperty("sessionCards")]
        public SessionCards SessionCards { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("hasLoveSeat")]
        public bool HasLoveSeat { get; set; }

        /// <summary>
        /// Examples: 730756462
        /// </summary>
        [JsonProperty("sessionId")]
        public int SessionId { get; set; }

        /// <summary>
        /// Examples: ["1","2","3","4","5","6","7","8"]
        /// </summary>
        [JsonProperty("rows")]
        public List<string> Rows { get; set; }

        /// <summary>
        /// Examples: 20
        /// </summary>
        [JsonProperty("colSize")]
        public int ColSize { get; set; }

        /// <summary>
        /// Examples: "730756462"
        /// </summary>
        [JsonProperty("partnerSessionId")]
        public string PartnerSessionId { get; set; }

        /// <summary>
        /// Examples: "0000000000000001"
        /// </summary>
        [JsonProperty("partnerHallId")]
        public string PartnerHallId { get; set; }

        /// <summary>
        /// Examples: "03-05"
        /// </summary>
        [JsonProperty("playDate")]
        public string PlayDate { get; set; }

        /// <summary>
        /// Examples: "您的特价资格已用完\n请按原价44元/张购买"
        /// </summary>
        [JsonProperty("overBuyTips")]
        public string OverBuyTips { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("realNameType")]
        public int RealNameType { get; set; }

        /// <summary>
        /// Examples: 8
        /// </summary>
        [JsonProperty("partnerId")]
        public string PartnerId { get; set; }

        /// <summary>
        /// Examples: ["观影需全程佩戴口罩，电影放映期间影厅内禁止饮食，感谢配合！"]
        /// </summary>
        [JsonProperty("cinemaNotice")]
        public List<string> CinemaNotice { get; set; }

        /// <summary>
        /// Examples: 0
        /// </summary>
        [JsonProperty("status")]
        public int Status { get; set; }

        /// <summary>
        /// Examples: "9733"
        /// </summary>
        [JsonProperty("partnerCinemaId")]
        public string PartnerCinemaId { get; set; }
    }
    public class SessionCards
    {

        /// <summary>
        /// Examples: [{"priceString":"44","price":44.0,"thirdFrom":"dadiv3","startTime":"10:30","sessionId":730756462,"partnerId":8,"endTime":"12:38","type":"汉语2D","partnerSessionId":"730756462","isVip":false,"partnerCinemaId":"9733","realPrice":44.0},{"priceString":"44","price":44.0,"thirdFrom":"dadiv3","startTime":"11:55","sessionId":731312405,"partnerId":8,"endTime":"14:03","type":"汉语2D","partnerSessionId":"731312405","isVip":false,"partnerCinemaId":"9733","realPrice":44.0},{"priceString":"44","price":44.0,"thirdFrom":"dadiv3","startTime":"12:55","sessionId":730756468,"partnerId":8,"endTime":"15:03","type":"汉语2D","partnerSessionId":"730756468","isVip":false,"partnerCinemaId":"9733","realPrice":44.0},{"priceString":"44","price":44.0,"thirdFrom":"dadiv3","startTime":"14:20","sessionId":731312410,"partnerId":8,"endTime":"16:28","type":"汉语2D","partnerSessionId":"731312410","isVip":false,"partnerCinemaId":"9733","realPrice":44.0},{"priceString":"44","price":44.0,"thirdFrom":"dadiv3","startTime":"15:20","sessionId":730756474,"partnerId":8,"endTime":"17:28","type":"汉语2D","partnerSessionId":"730756474","isVip":false,"partnerCinemaId":"9733","realPrice":44.0},{"priceString":"44","price":44.0,"thirdFrom":"dadiv3","startTime":"15:45","sessionId":731312412,"partnerId":8,"endTime":"17:53","type":"汉语2D","partnerSessionId":"731312412","isVip":false,"partnerCinemaId":"9733","realPrice":44.0},{"priceString":"44","price":44.0,"thirdFrom":"dadiv3","startTime":"16:45","sessionId":730756476,"partnerId":8,"endTime":"18:53","type":"汉语2D","partnerSessionId":"730756476","isVip":false,"partnerCinemaId":"9733","realPrice":44.0},{"priceString":"44","price":44.0,"thirdFrom":"dadiv3","startTime":"17:45","sessionId":730756480,"partnerId":8,"endTime":"19:53","type":"汉语2D","partnerSessionId":"730756480","isVip":false,"partnerCinemaId":"9733","realPrice":44.0},{"priceString":"44","price":44.0,"thirdFrom":"dadiv3","startTime":"18:20","sessionId":731312417,"partnerId":8,"endTime":"20:28","type":"汉语2D","partnerSessionId":"731312417","isVip":false,"partnerCinemaId":"9733","realPrice":44.0},{"priceString":"49","price":49.0,"thirdFrom":"dadiv3","startTime":"19:10","sessionId":730756481,"partnerId":8,"endTime":"21:18","type":"汉语2D","partnerSessionId":"730756481","isVip":false,"partnerCinemaId":"9733","realPrice":49.0},{"priceString":"49","price":49.0,"thirdFrom":"dadiv3","startTime":"20:10","sessionId":730756486,"partnerId":8,"endTime":"22:18","type":"汉语2D","partnerSessionId":"730756486","isVip":false,"partnerCinemaId":"9733","realPrice":49.0},{"priceString":"49","price":49.0,"thirdFrom":"dadiv3","startTime":"20:50","sessionId":731312420,"partnerId":8,"endTime":"22:58","type":"汉语2D","partnerSessionId":"731312420","isVip":false,"partnerCinemaId":"9733","realPrice":49.0},{"priceString":"44","price":44.0,"thirdFrom":"dadiv3","startTime":"21:35","sessionId":730756487,"partnerId":8,"endTime":"23:43","type":"汉语2D","partnerSessionId":"730756487","isVip":false,"partnerCinemaId":"9733","realPrice":44.0}]
        /// </summary>
        [JsonProperty("cardList")]
        public List<CardList> CardList { get; set; }

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("sessionCardType")]
        public bool SessionCardType { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("cardString")]
        public string CardString { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("hasMore")]
        public bool HasMore { get; set; }
    }
    public class AreaDiscountDisplay
    {

        /// <summary>
        /// Examples: "¥44"
        /// </summary>
        [JsonProperty("areaPrice")]
        public string AreaPrice { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("hasDiscount")]
        public bool HasDiscount { get; set; }

        /// <summary>
        /// Examples: "0", "1", "2"
        /// </summary>
        [JsonProperty("aid")]
        public string Aid { get; set; }
    }
    public class CardList
    {

        /// <summary>
        /// Examples: "44", "49"
        /// </summary>
        [JsonProperty("priceString")]
        public string PriceString { get; set; }

        /// <summary>
        /// Examples: 44.0, 49.0
        /// </summary>
        [JsonProperty("price")]
        public double Price { get; set; }

        /// <summary>
        /// Examples: "dadiv3"
        /// </summary>
        [JsonProperty("thirdFrom")]
        public string ThirdFrom { get; set; }

        /// <summary>
        /// Examples: "10:30", "11:55", "12:55", "14:20", "15:20"
        /// </summary>
        [JsonProperty("startTime")]
        public string StartTime { get; set; }

        /// <summary>
        /// Examples: 730756462, 731312405, 730756468, 731312410, 730756474
        /// </summary>
        [JsonProperty("sessionId")]
        public int SessionId { get; set; }

        /// <summary>
        /// Examples: 8
        /// </summary>
        [JsonProperty("partnerId")]
        public string PartnerId { get; set; }

        /// <summary>
        /// Examples: "12:38", "14:03", "15:03", "16:28", "17:28"
        /// </summary>
        [JsonProperty("endTime")]
        public string EndTime { get; set; }

        /// <summary>
        /// Examples: "汉语2D"
        /// </summary>
        [JsonProperty("type")]
        public string Type { get; set; }

        /// <summary>
        /// Examples: "730756462", "731312405", "730756468", "731312410", "730756474"
        /// </summary>
        [JsonProperty("partnerSessionId")]
        public string PartnerSessionId { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("isVip")]
        public bool IsVip { get; set; }

        /// <summary>
        /// Examples: "9733"
        /// </summary>
        [JsonProperty("partnerCinemaId")]
        public string PartnerCinemaId { get; set; }

        /// <summary>
        /// Examples: 44.0, 49.0
        /// </summary>
        [JsonProperty("realPrice")]
        public double RealPrice { get; set; }
    }
    public class AreaPriceChangeInfo
    {
    }

    public class PriceChangeInfo
    {
    }

}
