﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using iqiyiWin.Model;
using Newtonsoft.Json;

namespace iqiyiWin.Response.Task.TaskList
{
    public class GetTaskListResponse
    {

        /// <summary>
        /// Examples: {"totalRewardName":"观影豆","taskCompleteReward":50,"headImg":"https://www.iqiyipic.com/common/fix/headicons/male-130.png","nickName":"hopjdwrxy36540","totalReward":500,"isLogin":true,"forNow":"2.00","completeRaskNumber":5,"task":[{"rewardName":"观影豆","receive":false,"ladingPage":"qyticket://movieticketroot","rewardCount":25,"taskName":"首次标记\"想看\"电影","remark":"在电影列表中挑选自己想看的电影，在影片介绍页点击\"想看\"","complete":false},{"recordId":30803720,"rewardName":"观影豆","receive":false,"ladingPage":"qyticket://movieticketroot","rewardCount":25,"taskName":"首次体验在线选座","remark":"在电影列表中挑选想看的电影，体验在线选择座位并确认","complete":true},{"recordId":31926773,"rewardName":"观影豆","receive":false,"ladingPage":"https://app.iqiyi.com/ext/common/qipiao/libao_goumai/app.html?channel=piaoapp_flrw","rewardCount":200,"taskName":"首次购买超值礼包","remark":"","complete":true},{"rewardName":"观影豆","receive":false,"ladingPage":"qyticket://movieticketroot","rewardCount":200,"taskName":"首次购买电影票","remark":"1.完成首次购买电影票，在所购买场次观影日期结束后记做任务完成;\r\n2.每位用户仅限赠送1次。同一爱奇艺账号、手机号、设备、支付账号均视为同一用户。","complete":false},{"rewardName":"观影豆","receive":false,"ladingPage":"","rewardCount":50,"taskName":"完成全部新手任务","remark":"","complete":false}],"currentCount":200.0,"taskCompleteRewardName":"观影豆","taskNumber":5,"cash":"5.00"}
        /// </summary>
        [JsonProperty("data")]
        public Data Data { get; set; }

        /// <summary>
        /// Examples: "20210701155026"
        /// </summary>
        [JsonProperty("timestamp")]
        public string Timestamp { get; set; }

        /// <summary>
        /// Examples: "A00000"
        /// </summary>
        [JsonProperty("code")]
        public string Code { get; set; }

        /// <summary>
        /// Examples: "dedabc54-d4b5-41ae-adb6-bab0c0d991dc"
        /// </summary>
        [JsonProperty("requestId")]
        public string RequestId { get; set; }

        /// <summary>
        /// Examples: ""
        /// </summary>
        [JsonProperty("msg")]
        public string Msg { get; set; }

        /// <summary>
        /// Examples: false
        /// </summary>
        [JsonProperty("hasNext")]
        public bool HasNext { get; set; }
    }
    public class Data
    {

        /// <summary>
        /// Examples: "观影豆"
        /// </summary>
        [JsonProperty("totalRewardName")]
        public string TotalRewardName { get; set; }

        /// <summary>
        /// Examples: 50
        /// </summary>
        [JsonProperty("taskCompleteReward")]
        public int TaskCompleteReward { get; set; }

        /// <summary>
        /// Examples: "https://www.iqiyipic.com/common/fix/headicons/male-130.png"
        /// </summary>
        [JsonProperty("headImg")]
        public string HeadImg { get; set; }

        /// <summary>
        /// Examples: "hopjdwrxy36540"
        /// </summary>
        [JsonProperty("nickName")]
        public string NickName { get; set; }

        /// <summary>
        /// Examples: 500
        /// </summary>
        [JsonProperty("totalReward")]
        public int TotalReward { get; set; }

        /// <summary>
        /// Examples: true
        /// </summary>
        [JsonProperty("isLogin")]
        public bool IsLogin { get; set; }

        /// <summary>
        /// Examples: "2.00"
        /// </summary>
        [JsonProperty("forNow")]
        public string ForNow { get; set; }

        /// <summary>
        /// Examples: 5
        /// </summary>
        [JsonProperty("completeRaskNumber")]
        public int CompleteRaskNumber { get; set; }

        /// <summary>
        /// Examples: [{"rewardName":"观影豆","receive":false,"ladingPage":"qyticket://movieticketroot","rewardCount":25,"taskName":"首次标记\"想看\"电影","remark":"在电影列表中挑选自己想看的电影，在影片介绍页点击\"想看\"","complete":false},{"recordId":30803720,"rewardName":"观影豆","receive":false,"ladingPage":"qyticket://movieticketroot","rewardCount":25,"taskName":"首次体验在线选座","remark":"在电影列表中挑选想看的电影，体验在线选择座位并确认","complete":true},{"recordId":31926773,"rewardName":"观影豆","receive":false,"ladingPage":"https://app.iqiyi.com/ext/common/qipiao/libao_goumai/app.html?channel=piaoapp_flrw","rewardCount":200,"taskName":"首次购买超值礼包","remark":"","complete":true},{"rewardName":"观影豆","receive":false,"ladingPage":"qyticket://movieticketroot","rewardCount":200,"taskName":"首次购买电影票","remark":"1.完成首次购买电影票，在所购买场次观影日期结束后记做任务完成;\r\n2.每位用户仅限赠送1次。同一爱奇艺账号、手机号、设备、支付账号均视为同一用户。","complete":false},{"rewardName":"观影豆","receive":false,"ladingPage":"","rewardCount":50,"taskName":"完成全部新手任务","remark":"","complete":false}]
        /// </summary>
        [JsonProperty("task")]
        public List<IqiyiTask> Task { get; set; }

        /// <summary>
        /// Examples: 200.0
        /// </summary>
        [JsonProperty("currentCount")]
        public double CurrentCount { get; set; }

        /// <summary>
        /// Examples: "观影豆"
        /// </summary>
        [JsonProperty("taskCompleteRewardName")]
        public string TaskCompleteRewardName { get; set; }

        /// <summary>
        /// Examples: 5
        /// </summary>
        [JsonProperty("taskNumber")]
        public int TaskNumber { get; set; }

        /// <summary>
        /// Examples: "5.00"
        /// </summary>
        [JsonProperty("cash")]
        public string Cash { get; set; }
    }
}
