﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using iqiyiWin.Enums;
using iqiyiWin.Model;
using NLog;

namespace iqiyiWin.Util
{
    public class MyHttpListenerUtils
    {
        private static Logger logger = LogManager.GetCurrentClassLogger();
        private HttpListener MyListerner;
        public void OnStart()
        {
            MyListerner = new HttpListener();
            while (true)
            {
                try
                {
                    MyListerner.AuthenticationSchemes = AuthenticationSchemes.Anonymous;
                    MyListerner.Prefixes.Add("http://127.0.0.1:7788/iqiyiWin/updateToken/");
                    MyListerner.Start();
                }
                catch (Exception ex)
                {
                    UILogUtils.Error("服务器启动失败：" + ex.ToString());
                    break;
                }

                //线程池
                int minThreadNum;
                int portThreadNum;
                int maxThreadNum;
                ThreadPool.GetMaxThreads(out maxThreadNum, out portThreadNum);
                ThreadPool.GetMinThreads(out minThreadNum, out portThreadNum);
                while (true)
                {
                    //等待请求连接
                    //没有请求则GetContext处于阻塞状态
                    HttpListenerContext ctx = MyListerner.GetContext();

                    ThreadPool.QueueUserWorkItem(new WaitCallback(TaskProc), ctx);
                }
            }
        }

        public void OnStop()
        {
            MyListerner?.Stop();
        }

        void TaskProc(object obj)
        {
            HttpListenerContext ctx = (HttpListenerContext)obj;

            ctx.Response.StatusCode = 200;
            ctx.Response.ContentType = "application/json";
            ctx.Response.AppendHeader("Access-Control-Allow-Origin", "*");

            var replyMsg = "{success:true}";
            

            //使用Writer输出http响应代码,UTF8格式
            using (StreamWriter writer = new StreamWriter(ctx.Response.OutputStream, Encoding.UTF8))
            {
                writer.Write(replyMsg);
                writer.Close();
                Main._this.ReacquireCookieBack(new IqiyiAccount()
                {
                    MobileNo = ctx.Request.QueryString["mobile"],
                    Password = ctx.Request.QueryString["password"],
                    Cookie = ctx.Request.QueryString["token"],
                    Status = (int)ReacquireCookieEnums.ReacquireSuccess
                });
                ctx.Response.Close();
            }
        }
    }
}
